searchData={"items":[{"type":"module","title":"euneus","doc":null,"ref":"euneus.html"},{"type":"function","title":"euneus.decode/1","doc":"Decodes a binary JSON into a term. Example: 1 &gt; euneus : decode ( &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt; ) . &lt;&lt; &quot;foo&quot; &gt;&gt;","ref":"euneus.html#decode/1"},{"type":"function","title":"euneus.decode/2","doc":"Decodes a binary JSON into a term. Example: 1 &gt; euneus : decode ( &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt; , #{ } ) . &lt;&lt; &quot;foo&quot; &gt;&gt;","ref":"euneus.html#decode/2"},{"type":"function","title":"euneus.decode_iodata/1","doc":"Decodes an iodata JSON into a term. Example: 1 &gt; euneus : decode_iodata ( [ $&quot; , &lt;&lt; &quot;foo&quot; &gt;&gt; , $&quot; ] ) . &lt;&lt; &quot;foo&quot; &gt;&gt;","ref":"euneus.html#decode_iodata/1"},{"type":"function","title":"euneus.decode_iodata/2","doc":"Decodes an iodata JSON into a term. Example: 1 &gt; euneus : decode_iodata ( [ $&quot; , &lt;&lt; &quot;foo&quot; &gt;&gt; , $&quot; ] , #{ } ) . &lt;&lt; &quot;foo&quot; &gt;&gt;","ref":"euneus.html#decode_iodata/2"},{"type":"function","title":"euneus.encode/1","doc":"Encodes a term into a binary JSON. Example: 1 &gt; euneus : encode ( foo ) . &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt;","ref":"euneus.html#encode/1"},{"type":"function","title":"euneus.encode/2","doc":"Encodes a term into a binary JSON. Example: 1 &gt; euneus : encode ( foo , #{ } ) . &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt;","ref":"euneus.html#encode/2"},{"type":"function","title":"euneus.encode_to_iodata/1","doc":"Encodes a term into an iodata JSON. Example: 1 &gt; euneus : encode_to_iodata ( foo ) . [ $&quot; , &lt;&lt; &quot;foo&quot; &gt;&gt; , $&quot; ]","ref":"euneus.html#encode_to_iodata/1"},{"type":"function","title":"euneus.encode_to_iodata/2","doc":"Encodes a term into an iodata JSON. Example: 1 &gt; euneus : encode_to_iodata ( foo , #{ } ) . [ $&quot; , &lt;&lt; &quot;foo&quot; &gt;&gt; , $&quot; ]","ref":"euneus.html#encode_to_iodata/2"},{"type":"function","title":"euneus.format/2","doc":"Formats a binary JSON. Example: 1 &gt; Opts = #{ . . indent_type =&gt; tabs , . . indent_width =&gt; 1 , . . spaced_values =&gt; true , . . crlf =&gt; n . . } . #{ indent_type =&gt; tabs , indent_width =&gt; 1 , spaced_values =&gt; true , crlf =&gt; n } 2 &gt; euneus : format ( &lt;&lt; &quot; \\n{\\&quot;foo\\&quot; : [ true , \\n null ] \\n } &quot; &gt;&gt; , Opts ) . &lt;&lt; &quot;{\\n\\t\\&quot;foo\\&quot;: [\\n\\t\\ttrue,\\n\\t\\tnull\\n\\t]\\n}&quot; &gt;&gt;","ref":"euneus.html#format/2"},{"type":"function","title":"euneus.minify/1","doc":"Minifies a binary JSON. Example: 1 &gt; euneus : minify ( &lt;&lt; &quot; \\n{\\&quot;foo\\&quot; : [ true , \\n null ] \\n } &quot; &gt;&gt; ) . &lt;&lt; &quot;{\\&quot;foo\\&quot;:[true,null]}&quot; &gt;&gt;","ref":"euneus.html#minify/1"},{"type":"module","title":"euneus_decoder","doc":null,"ref":"euneus_decoder.html"},{"type":"function","title":"euneus_decoder.decode/2","doc":"Decodes a binary JSON into a term. Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt; , #{ } ) . &lt;&lt; &quot;foo&quot; &gt;&gt; Option details: codecs - Transforms a JSON binary value into an Erlang term. By returning next , the next codec will be called, or by returning {halt, Term :: term()} , the Term is returned as the value. You can use the built-in codecs or your own. Please see the euneus_decoder:codec/0 type for details. Default is [] . Built-in codecs: timestamp - Transforms an ISO 8601 string with milliseconds into an erlang:timestamp/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;1970-01-01T00:00:00.000Z\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ timestamp ] } ) . { 0 , 0 , 0 } datetime - Transforms an ISO 8601 string into a calendar:datetime/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;1970-01-01T00:00:00Z\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ datetime ] } ) . { { 1970 , 01 , 01 } , { 00 , 00 , 00 } } ipv4 - Transforms a JSON string into an inet:ip4_address/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;127.0.0.1\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv4 ] } ) . { 127 , 0 , 0 , 1 } ipv6 - Transforms a JSON string into an inet:ip6_address/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;::\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv6 ] } ) . { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 } 2 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;::1\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv6 ] } ) . { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 1 } 3 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;::192.168.42.2\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv6 ] } ) . { 0 , 0 , 0 , 0 , 0 , 0 , ( 192 bsl 8 ) bor 168 , ( 42 bsl 8 ) bor 2 } 4 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;::ffff:192.168.42.2\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv6 ] } ) . { 0 , 0 , 0 , 0 , 0 , 16#FFFF , ( 192 bsl 8 ) bor 168 , ( 42 bsl 8 ) bor 2 } 5 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;3ffe:b80:1f8d:2:204:acff:fe17:bf38\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv6 ] } ) . { 16#3ffe , 16#b80 , 16#1f8d , 16#2 , 16#204 , 16#acff , 16#fe17 , 16#bf38 } 6 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;fe80::204:acff:fe17:bf38\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ ipv6 ] } ) . { 16#fe80 , 0 , 0 , 0 , 16#204 , 16#acff , 16#fe17 , 16#bf38 } pid - Transforms a JSON string into an erlang:pid/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;&lt;0.92.0&gt;\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ pid ] } ) . . =:= list_to_pid ( &quot;&lt;0.92.0&gt;&quot; ) . true port - Transforms a JSON string into an erlang:port/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;#Port&lt;0.1&gt;\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ port ] } ) . . =:= list_to_port ( &quot;#Port&lt;0.1&gt;&quot; ) . true reference - Transforms a JSON string into an erlang:reference/0 . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;\\&quot;#Ref&lt;0.314572725.1088159747.110918&gt;\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ reference ] } ) . . =:= list_to_ref ( &quot;#Ref&lt;0.314572725.1088159747.110918&gt;&quot; ) . true Custom codec example: 1 &gt; euneus : decode ( &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt; , #{ codecs =&gt; [ fun ( &lt;&lt; &quot;foo&quot; &gt;&gt; ) -&gt; { halt , foo } end ] } ) . foo null - Defines which term should be considered null. Default is null . Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;null&quot; &gt;&gt; , #{ null =&gt; nil } ) . nil binary_to_float - Overrides the default binary to float conversion. binary_to_integer - Overrides the default binary to integer conversion.. array_start - Overrides the json:array_start_fun/0 callback. array_push - Overrides the json:array_push_fun/0 callback. array_finish - Overrides the json:array_finish_fun/0 callback. In addition to the custom function, there are: ordered - Returns the array in the same order as the JSON. That's the slower option. Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;[1,2,3]&quot; &gt;&gt; , #{ array_finish =&gt; ordered } ) . [ 1 , 2 , 3 ] reversed - Returns the array in a reversed order. That's the faster option. Example: 1 &gt; euneus_decoder : decode ( &lt;&lt; &quot;[1,2,3]&quot; &gt;&gt; , #{ array_finish =&gt; reversed } ) . [ 3 , 2 , 1 ] Default is ordered . object_start - Overrides the json:object_start_fun/0 callback. object_keys - Transforms JSON objects key into Erlang term. In addition to the custom function, there are: binary - Returns the key as erlang:binary/0 . copy - Copies the key via binary:copy/1 returning it as erlang:binary/0 . atom - Returns the key as erlang:atom/0 via erlang:binary_to_atom/2 . existing_atom - Returns the key as erlang:atom/0 via erlang:binary_to_existing_atom/2 . Default is binary . object_push - Overrides the json:object_push_fun/0 callback. object_finish - Overrides the json:object_finish_fun/0 callback. In addition to the custom function, there are: map - Returns the object as a erlang:map/0 . That's the slower option. Example: 1 &gt; euneus_decoder : decode ( . . &lt;&lt; &quot;{\\&quot;a\\&quot;:\\&quot;a\\&quot;,\\&quot;b\\&quot;:\\&quot;b\\&quot;,\\&quot;c\\&quot;:\\&quot;c\\&quot;}&quot; &gt;&gt; , . . #{ object_finish =&gt; map } . . ) . #{ &lt;&lt; &quot;a&quot; &gt;&gt; =&gt; &lt;&lt; &quot;a&quot; &gt;&gt; , &lt;&lt; &quot;b&quot; &gt;&gt; =&gt; &lt;&lt; &quot;b&quot; &gt;&gt; , &lt;&lt; &quot;c&quot; &gt;&gt; =&gt; &lt;&lt; &quot;c&quot; &gt;&gt; } proplist - Returns the object as an ordered proplists:proplist/0 . Example: 1 &gt; euneus_decoder : decode ( . . &lt;&lt; &quot;{\\&quot;a\\&quot;:\\&quot;a\\&quot;,\\&quot;b\\&quot;:\\&quot;b\\&quot;,\\&quot;c\\&quot;:\\&quot;c\\&quot;}&quot; &gt;&gt; , . . #{ object_finish =&gt; proplist } . . ) . [ { &lt;&lt; &quot;a&quot; &gt;&gt; , &lt;&lt; &quot;a&quot; &gt;&gt; } , { &lt;&lt; &quot;b&quot; &gt;&gt; , &lt;&lt; &quot;b&quot; &gt;&gt; } , { &lt;&lt; &quot;c&quot; &gt;&gt; , &lt;&lt; &quot;c&quot; &gt;&gt; } ] reversed_proplist - Returns the object as a reversed proplists:proplist/0 . That's the faster option. Example: 1 &gt; euneus_decoder : decode ( . . &lt;&lt; &quot;{\\&quot;a\\&quot;:\\&quot;a\\&quot;,\\&quot;b\\&quot;:\\&quot;b\\&quot;,\\&quot;c\\&quot;:\\&quot;c\\&quot;}&quot; &gt;&gt; , . . #{ object_finish =&gt; reversed_proplist } . . ) . [ { &lt;&lt; &quot;c&quot; &gt;&gt; , &lt;&lt; &quot;c&quot; &gt;&gt; } , { &lt;&lt; &quot;b&quot; &gt;&gt; , &lt;&lt; &quot;b&quot; &gt;&gt; } , { &lt;&lt; &quot;a&quot; &gt;&gt; , &lt;&lt; &quot;a&quot; &gt;&gt; } ] Default is map .","ref":"euneus_decoder.html#decode/2"},{"type":"type","title":"euneus_decoder.codec/0","doc":null,"ref":"euneus_decoder.html#t:codec/0"},{"type":"type","title":"euneus_decoder.codec_callback/0","doc":null,"ref":"euneus_decoder.html#t:codec_callback/0"},{"type":"type","title":"euneus_decoder.options/0","doc":null,"ref":"euneus_decoder.html#t:options/0"},{"type":"module","title":"euneus_encoder","doc":null,"ref":"euneus_encoder.html"},{"type":"function","title":"euneus_encoder.encode/2","doc":"Encode a term into an iodata JSON. Example: 1 &gt; euneus_encoder : encode ( foo , #{ } ) . [ $&quot; , &lt;&lt; &quot;foo&quot; &gt;&gt; , $&quot; ] Option details: Note For better visualization and understanding, all options examples use euneus:encode/2 , which returns a binary. codecs - Transforms tuples into any other Erlang term that will be encoded again into a JSON value. By returning next , the next codec will be called, or by returning {halt, Term :: term()} , the Term will be encoded again. You can use the built-in codecs or your own. Please see the euneus_encoder:codec/0 type for details. Default is [] . Built-in codecs: timestamp - Transforms an erlang:timestamp/0 into an ISO 8601 string with milliseconds. Example: 1 &gt; euneus : encode ( { 0 , 0 , 0 } , #{ codecs =&gt; [ timestamp ] } ) . &lt;&lt; &quot;\\&quot;1970-01-01T00:00:00.000Z\\&quot;&quot; &gt;&gt; datetime - Transforms a calendar:datetime/0 into an ISO 8601 string. Example: 1 &gt; euneus : encode ( { { 1970 , 01 , 01 } , { 00 , 00 , 00 } } , #{ codecs =&gt; [ datetime ] } ) . &lt;&lt; &quot;\\&quot;1970-01-01T00:00:00Z\\&quot;&quot; &gt;&gt; ipv4 - Transforms an inet:ip4_address/0 into a JSON string. Example: 1 &gt; euneus : encode ( { 127 , 0 , 0 , 1 } , #{ codecs =&gt; [ ipv4 ] } ) . &lt;&lt; &quot;\\&quot;127.0.0.1\\&quot;&quot; &gt;&gt; ipv6 - Transforms an inet:ip6_address/0 into a JSON string. Example: 1 &gt; euneus : encode ( { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 } , #{ codecs =&gt; [ ipv6 ] } ) . &lt;&lt; &quot;\\&quot;::\\&quot;&quot; &gt;&gt; 2 &gt; euneus : encode ( { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 1 } , #{ codecs =&gt; [ ipv6 ] } ) . &lt;&lt; &quot;\\&quot;::1\\&quot;&quot; &gt;&gt; 3 &gt; euneus : encode ( . . { 0 , 0 , 0 , 0 , 0 , 0 , ( 192 bsl 8 ) bor 168 , ( 42 bsl 8 ) bor 2 } , . . #{ codecs =&gt; [ ipv6 ] } . . ) . &lt;&lt; &quot;\\&quot;::192.168.42.2\\&quot;&quot; &gt;&gt; 4 &gt; euneus : encode ( . . { 0 , 0 , 0 , 0 , 0 , 16#FFFF , ( 192 bsl 8 ) bor 168 , ( 42 bsl 8 ) bor 2 } , . . #{ codecs =&gt; [ ipv6 ] } . . ) . &lt;&lt; &quot;\\&quot;::ffff:192.168.42.2\\&quot;&quot; &gt;&gt; 5 &gt; euneus : encode ( . . { 16#3ffe , 16#b80 , 16#1f8d , 16#2 , 16#204 , 16#acff , 16#fe17 , 16#bf38 } , . . #{ codecs =&gt; [ ipv6 ] } . . ) . &lt;&lt; &quot;\\&quot;3ffe:b80:1f8d:2:204:acff:fe17:bf38\\&quot;&quot; &gt;&gt; 6 &gt; euneus : encode ( . . { 16#fe80 , 0 , 0 , 0 , 16#204 , 16#acff , 16#fe17 , 16#bf38 } , . . #{ codecs =&gt; [ ipv6 ] } . . ) . &lt;&lt; &quot;\\&quot;fe80::204:acff:fe17:bf38\\&quot;&quot; &gt;&gt; records - Transforms records into JSON objects. Example: 1 &gt; euneus : encode ( . . % Same as &#39;-record(foo, {bar, baz}).&#39; . . { foo , bar , baz } , . . #{ codecs =&gt; [ { records , #{ . . % Same as &#39;foo =&gt; {record_info(fields, foo), record_info(size, foo)}&#39; . . foo =&gt; { [ bar , baz ] , 3 } . . } } ] } . . ) . &lt;&lt; &quot;{\\&quot;bar\\&quot;:\\&quot;bar\\&quot;,\\&quot;baz\\&quot;:\\&quot;baz\\&quot;}&quot; &gt;&gt; Custom codec example: 1 &gt; euneus : encode ( { foo } , #{ codecs =&gt; [ fun ( { foo } ) -&gt; { halt , foo } end ] } ) . &lt;&lt; &quot;\\&quot;foo\\&quot;&quot; &gt;&gt; nulls - Defines which values should be encoded as null. Default is [null] . Example: 1 &gt; euneus : encode ( [ null , nil , foo ] , #{ nulls =&gt; [ null , nil ] } ) . &lt;&lt; &quot;[null,null,\\&quot;foo\\&quot;]&quot; &gt;&gt; skip_values - Defines which map values should be ignored. This option permits achieves the same behavior as Javascript, which ignores undefined values of objects. Default is [undefined] . Example: 1 &gt; euneus : encode ( . . #{ foo =&gt; bar , bar =&gt; undefined , baz =&gt; null } , . . #{ skip_values =&gt; [ undefined , null ] } . . ) . &lt;&lt; &quot;{\\&quot;foo\\&quot;:\\&quot;bar\\&quot;}&quot; &gt;&gt; key_to_binary - Overrides the default conversion of map keys to a string. sort_keys - Defines if the object keys should be sorted. Default is false . Example: 1 &gt; euneus : encode ( #{ c =&gt; c , a =&gt; a , b =&gt; b } , #{ sort_keys =&gt; true } ) . &lt;&lt; &quot;{\\&quot;a\\&quot;:\\&quot;a\\&quot;,\\&quot;b\\&quot;:\\&quot;b\\&quot;,\\&quot;c\\&quot;:\\&quot;c\\&quot;}&quot; &gt;&gt; proplists - If true, converts proplists into objects. Default is false . Example: 1 &gt; euneus : encode ( [ { foo , bar } , baz ] , #{ proplists =&gt; true } ) . &lt;&lt; &quot;{\\&quot;foo\\&quot;:\\&quot;bar\\&quot;,\\&quot;baz\\&quot;:true}&quot; &gt;&gt; 2 &gt; euneus : encode ( . . [ { foo , bar } , { baz , true } ] , . . % Overrides the default is proplist check: . . #{ proplists =&gt; { true , fun ( [ { _ , _ } | _ ] ) -&gt; true end } } . . ) . &lt;&lt; &quot;{\\&quot;foo\\&quot;:\\&quot;bar\\&quot;,\\&quot;baz\\&quot;:true}&quot; &gt;&gt; escape - Overrides the default string escaping. encode_integer - Overrides the default integer encoder. encode_float - Overrides the default float encoder. encode_atom - Overrides the default atom encoder. encode_list - Overrides the default list encoder. encode_map - Overrides the default map encoder. encode_tuple - Overrides the default tuple encoder. encode_pid - Overrides the default pid encoder. encode_port - Overrides the default port encoder. encode_reference - Overrides the default reference encoder.","ref":"euneus_encoder.html#encode/2"},{"type":"type","title":"euneus_encoder.codec/0","doc":null,"ref":"euneus_encoder.html#t:codec/0"},{"type":"type","title":"euneus_encoder.codec_callback/0","doc":null,"ref":"euneus_encoder.html#t:codec_callback/0"},{"type":"type","title":"euneus_encoder.encode/1","doc":null,"ref":"euneus_encoder.html#t:encode/1"},{"type":"type","title":"euneus_encoder.is_proplist/0","doc":null,"ref":"euneus_encoder.html#t:is_proplist/0"},{"type":"type","title":"euneus_encoder.options/0","doc":null,"ref":"euneus_encoder.html#t:options/0"},{"type":"opaque","title":"euneus_encoder.state/0","doc":null,"ref":"euneus_encoder.html#t:state/0"},{"type":"module","title":"euneus_formatter","doc":null,"ref":"euneus_formatter.html"},{"type":"function","title":"euneus_formatter.format/2","doc":"Formats a binary JSON. Option details: Note There is no default for any option, all are required. indent_type - Indent using tabs or spaces . tabs - The indent char will be $\\t . spaces - The indent char will be $\\s . indent_width - The indent_type will be copied N times based on it. spaced_values - Defines if keys and values of objects should be spaced by one $\\s char. crlf - Defines the Carriage Return/Line Feed. r - The CRLF will be &lt;&lt;$\\r&gt;&gt; . n - The CRLF will be &lt;&lt;$\\n&gt;&gt; . rn - The CRLF will be &lt;&lt;$\\r, $\\n&gt;&gt; . none - The CRLF will be &lt;&lt;&gt;&gt; .","ref":"euneus_formatter.html#format/2"},{"type":"type","title":"euneus_formatter.crlf/0","doc":null,"ref":"euneus_formatter.html#t:crlf/0"},{"type":"type","title":"euneus_formatter.options/0","doc":null,"ref":"euneus_formatter.html#t:options/0"},{"type":"extras","title":"Overview","doc":"# Euneus\n\nAn incredibly flexible and performant JSON parser, generator and formatter in pure Erlang.\n\nEuneus is built on the top of the new [OTP json module](https://erlang.org/documentation/doc-15.0-rc3/lib/stdlib-6.0/doc/html/json.html).\n\nBoth encoder and decoder fully conform to [RFC 8259](https://datatracker.ietf.org/doc/html/rfc8259)\nand [ECMA 404](https://ecma-international.org/publications-and-standards/standards/ecma-404/) standards\nand are tested using [JSONTestSuite](https://github.com/nst/JSONTestSuite).\n\nDetailed examples and further explanation can be found at [hexdocs](https://hexdocs.pm/euneus).","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Erlang - Overview","doc":"```erlang\n% rebar.config\n{deps, [\n    {json_polyfill, \"0.1.3\"}, % Required only for OTP < 27\n    {euneus, \"2.1.0\"}\n]}.\n```","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Overview","doc":"```elixir\n# mix.exs\ndefp deps do\n  [\n    {:json_polyfill, \"~> 0.1\"}, # Required only for OTP < 27\n    {:euneus, \"~> 2.1\"}\n  ]\nend\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Basic usage - Overview","doc":"```erlang\n1> euneus:encode(#{age => 68, name => <<\"Joe Armstrong\">>, nationality => <<\"British\">>}).\n<<\"{\\\"name\\\":\\\"Joe Armstrong\\\",\\\"age\\\":68,\\\"nationality\\\":\\\"British\\\"}\">>\n2> euneus:decode(v(1)).\n#{<<\"age\">> => 68,<<\"name\">> => <<\"Joe Armstrong\">>,<<\"nationality\">> => <<\"British\">>}\n```","ref":"readme.html#basic-usage"},{"type":"extras","title":"Encode - Overview","doc":"The functions `euneus:encode/1` `euneus:encode/2` encodes an Erlang term into a binary JSON.\nThe second argument of `euneus:encode/2` are options.\n\nPlease see the `m:euneus_encoder` [documentation](https://hexdocs.pm/euneus/doc/euneus_encoder.html)\nfor more examples and detailed explanation.\n\nThe data mapping and error reasons can be found in the OTP json encode function [documentation](https://erlang.org/documentation/doc-15.0-rc3/lib/stdlib-6.0/doc/html/json.html#encode/1).","ref":"readme.html#encode"},{"type":"extras","title":"Decode - Overview","doc":"The functions `euneus:decode/1` and `euneus:decode/2` decodes a binary JSON into an Erlang term.\nThe second argument of `euneus:decode/2` are options.\n\nPlease see the `m:euneus_decoder` [documentation](https://hexdocs.pm/euneus/doc/euneus_decoder.html)\nfor more examples and detailed explanation.\n\nThe data mapping and error reasons can be found in the OTP json decode function [documentation](https://erlang.org/documentation/doc-15.0-rc3/lib/stdlib-6.0/doc/html/json.html#decode/1).","ref":"readme.html#decode"},{"type":"extras","title":"Format - Overview","doc":"Two functions provide JSON formatting:\n\n- `euneus:minify/1` - Removes any extra spaces and new line characters;\n- `euneus:format/2` - Formats the JSON by passing custom options.\n\nPlease see the `m:euneus_formatter` [documentation](https://hexdocs.pm/euneus/doc/euneus_formatter.html)\nfor more examples and detailed explanation.","ref":"readme.html#format"},{"type":"extras","title":"Benchmark - Overview","doc":"The benchmarks are implemented very simply, but they are a good start foroptimizing\nEuneus since no optimizations have been made. You will find the benchmark commands\nin `euneus_benchmarker`, and data and tests under the test folder.\n\n> [!IMPORTANT]\n> For the first benchmark run, bootstrapping `erlperf` is required:\n>\n> ```console\n> $ rebar3 as benchmark shell\n>\n> 1> euneus_benchmarker:bootstrap().\n> ===> Verifying dependencies...\n> ===> Analyzing applications...\n> ===> Compiling erlperf\n> ===> Building escript for erlperf...\n> ok\n> ```","ref":"readme.html#benchmark"},{"type":"extras","title":"Results - Overview","doc":"> Setup:\n>\n> - OS : Linux\n> - CPU: 12th Gen Intel(R) Core(TM) i9-12900HX\n> - VM : Erlang/OTP 27 [erts-15.0.1] [source] [64-bit] [smp:24:24] [ds:24:24:10] [async-threads:1] [jit:ns]\n\n```console\n$ rebar3 as benchmark shell\n\n1> euneus_benchmarker:encode_benchmark().\nCode      ||   Samples       Avg   StdDev    Median      P99  Iteration    Rel\njiffy      1         3        37    2.70%        37       38   27036 us   100%\neuneus     1         3        24    6.28%        24       26   41110 us    66%\nthoas      1         3        14    4.22%        14       14   73195 us    37%\n\n2> euneus_benchmarker:decode_benchmark().\nCode       ||   Samples       Avg   StdDev    Median      P99  Iteration    Rel\neuneus      1         3        24    2.44%        24       24   42268 us   100%\njiffy       1         3        19    3.09%        19       19   53589 us    79%\nthoas       1         3        14    0.00%        14       14   71452 us    59%\n```\n\n> [!NOTE]\n> Since `erlperf` currently does not accept labels, `Code` returns something like:\n>\n> - euneus_benchmarker:encode_benchmark/0:\n>   - #Fun  = euneus\n>   - #Fun  = jiffy\n>   - #Fun  = thoas\n> - euneus_benchmarker:decode_benchmark/0:\n>   - #Fun  = euneus\n>   - #Fun  = jiffy\n>   - #Fun  = thoas","ref":"readme.html#results"},{"type":"extras","title":"Sponsors - Overview","doc":"If you like this tool, please consider [sponsoring me](https://github.com/sponsors/williamthome).\nI'm thankful for your never-ending support :heart:\n\nI also accept coffees :coffee:\n\n[![\"Buy Me A Coffee\"](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/williamthome)","ref":"readme.html#sponsors"},{"type":"extras","title":"License - Overview","doc":"Copyright (c) 2024 [William Fank Thomé](https://github.com/williamthome)\n\nEuneus is 100% open-source and community-driven. All components are\navailable under the Apache 2 License on [GitHub](https://github.com/williamthome/euneus).\n\nSee [LICENSE.md](LICENSE.md) for more information.","ref":"readme.html#license"},{"type":"extras","title":"License","doc":"# Apache License\n\nVersion 2.0, January 2004\n\n \n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions - License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution - License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions - License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks - License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty - License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability - License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability - License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nCopyright 2024, William Fank Thomé  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n \n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nSee the [Releases](https://github.com/williamthome/euneus/releases) page.","ref":"changelog.html"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"We as members, contributors, and leaders pledge to make participation in our\ncommunity a harassment-free experience for everyone, regardless of age, body\nsize, visible or invisible disability, ethnicity, sex characteristics, gender\nidentity and expression, level of experience, education, socio-economic status,\nnationality, personal appearance, race, caste, color, religion, or sexual\nidentity and orientation.\n\nWe pledge to act and interact in ways that contribute to an open, welcoming,\ndiverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to a positive environment for our\ncommunity include:\n\n* Demonstrating empathy and kindness toward other people\n* Being respectful of differing opinions, viewpoints, and experiences\n* Giving and gracefully accepting constructive feedback\n* Accepting responsibility and apologizing to those affected by our mistakes,\n  and learning from the experience\n* Focusing on what is best not just for us as individuals, but for the overall\n  community\n\nExamples of unacceptable behavior include:\n\n* The use of sexualized language or imagery, and sexual attention or advances of\n  any kind\n* Trolling, insulting or derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or email address,\n  without their explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Enforcement Responsibilities - Code of Conduct","doc":"Community leaders are responsible for clarifying and enforcing our standards of\nacceptable behavior and will take appropriate and fair corrective action in\nresponse to any behavior that they deem inappropriate, threatening, offensive,\nor harmful.\n\nCommunity leaders have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct, and will communicate reasons for moderation\ndecisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies within all community spaces, and also applies when\nan individual is officially representing the community in public spaces.\nExamples of representing our community include using an official email address,\nposting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported to the community leaders responsible for enforcement at\n[INSERT CONTACT METHOD].\nAll complaints will be reviewed and investigated promptly and fairly.\n\nAll community leaders are obligated to respect the privacy and security of the\nreporter of any incident.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Enforcement Guidelines - Code of Conduct","doc":"Community leaders will follow these Community Impact Guidelines in determining\nthe consequences for any action they deem in violation of this Code of Conduct:","ref":"code_of_conduct.html#enforcement-guidelines"},{"type":"extras","title":"1. Correction - Code of Conduct","doc":"**Community Impact**: Use of inappropriate language or other behavior deemed\nunprofessional or unwelcome in the community.\n\n**Consequence**: A private, written warning from community leaders, providing\nclarity around the nature of the violation and an explanation of why the\nbehavior was inappropriate. A public apology may be requested.","ref":"code_of_conduct.html#1-correction"},{"type":"extras","title":"2. Warning - Code of Conduct","doc":"**Community Impact**: A violation through a single incident or series of\nactions.\n\n**Consequence**: A warning with consequences for continued behavior. No\ninteraction with the people involved, including unsolicited interaction with\nthose enforcing the Code of Conduct, for a specified period of time. This\nincludes avoiding interactions in community spaces as well as external channels\nlike social media. Violating these terms may lead to a temporary or permanent\nban.","ref":"code_of_conduct.html#2-warning"},{"type":"extras","title":"3. Temporary Ban - Code of Conduct","doc":"**Community Impact**: A serious violation of community standards, including\nsustained inappropriate behavior.\n\n**Consequence**: A temporary ban from any sort of interaction or public\ncommunication with the community for a specified period of time. No public or\nprivate interaction with the people involved, including unsolicited interaction\nwith those enforcing the Code of Conduct, is allowed during this period.\nViolating these terms may lead to a permanent ban.","ref":"code_of_conduct.html#3-temporary-ban"},{"type":"extras","title":"4. Permanent Ban - Code of Conduct","doc":"**Community Impact**: Demonstrating a pattern of violation of community\nstandards, including sustained inappropriate behavior, harassment of an\nindividual, or aggression toward or disparagement of classes of individuals.\n\n**Consequence**: A permanent ban from any sort of public interaction within the\ncommunity.","ref":"code_of_conduct.html#4-permanent-ban"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage],\nversion 2.1, available at\n[https://www.contributor-covenant.org/version/2/1/code_of_conduct.html][v2.1].\n\nCommunity Impact Guidelines were inspired by\n[Mozilla's code of conduct enforcement ladder][Mozilla CoC].\n\nFor answers to common questions about this code of conduct, see the FAQ at\n[https://www.contributor-covenant.org/faq][FAQ]. Translations are available at\n[https://www.contributor-covenant.org/translations][translations].\n\n[homepage]: https://www.contributor-covenant.org\n[v2.1]: https://www.contributor-covenant.org/version/2/1/code_of_conduct.html\n[Mozilla CoC]: https://github.com/mozilla/diversity\n[FAQ]: https://www.contributor-covenant.org/faq\n[translations]: https://www.contributor-covenant.org/translations","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"Contributing","doc":"# Contributing to Euneus\n\n1. [License](#license)\n1. [Reporting a bug](#reporting-a-bug)\n1. [Requesting or implementing a feature](#requesting-or-implementing-a-feature)\n1. [Submitting your changes](#submitting-your-changes)\n   1. [Code Style](#code-style)\n   1. [Committing your changes](#committing-your-changes)\n   1. [Pull requests and branching](#pull-requests-and-branching)\n   1. [Credits](#credits)","ref":"contributing.html"},{"type":"extras","title":"License - Contributing","doc":"Euneus is licensed under the [Apache License Version 2.0](LICENSE.md), for all code.","ref":"contributing.html#license"},{"type":"extras","title":"Reporting a bug - Contributing","doc":"Euneus is not perfect software and will be buggy.\n\nBugs can be reported via\n[GitHub issues: bug report](https://github.com/williamthome/euneus/issues/new?template=bug_report.md).\n\nSome contributors and maintainers may be unpaid developers working on Euneus, in their own time,\nwith limited resources. We ask for respect and understanding, and will provide the same back.\n\nIf your contribution is an actual bug fix, we ask you to include tests that, not only show the issue\nis solved, but help prevent future regressions related to it.","ref":"contributing.html#reporting-a-bug"},{"type":"extras","title":"Requesting or implementing a feature - Contributing","doc":"Before requesting or implementing a new feature, do the following:\n\n- search, in existing [issues](https://github.com/williamthome/euneus/issues) (open or closed),\nwhether the feature might already be in the works, or has already been rejected,\n- make sure you're using the latest software release (or even the latest code, if you're going for\n_bleeding edge_).\n\nIf this is done, open up a\n[GitHub issues: feature request](https://github.com/williamthome/euneus/issues/new?template=feature_request.md).\n\nWe may discuss details with you regarding the implementation, and its inclusion within the project.\n\nWe try to have as many of Euneus's features tested as possible. Everything that a user can do,\nand is repeatable in any way, should be tested, to guarantee backwards compatible.","ref":"contributing.html#requesting-or-implementing-a-feature"},{"type":"extras","title":"Submitting your changes - Contributing","doc":"","ref":"contributing.html#submitting-your-changes"},{"type":"extras","title":"Code Style - Contributing","doc":"- do not introduce trailing whitespace\n- indentation is 4 spaces, not tabs\n- try not to introduce lines longer than 100 characters\n- write small functions whenever possible, and use descriptive names for functions and variables\n- comment tricky or non-obvious decisions made to explain their rationale","ref":"contributing.html#code-style"},{"type":"extras","title":"Committing your changes - Contributing","doc":"Merging to the `main` branch will usually be preceded by a squash.\n\nWhile it's Ok (and expected) your commit messages relate to why a given change was made, be aware\nthat the final commit (the merge one) will be the issue title, so it's important it is as specific\nas possible. This will also help eventual automated changelog generation.","ref":"contributing.html#committing-your-changes"},{"type":"extras","title":"Pull requests and branching - Contributing","doc":"All fixes to Euneus end up requiring a +1 from one or more of the project's maintainers.\n\nDuring the review process, you may be asked to correct or edit a few things before a final rebase\nto merge things. Do send edits as individual commits to allow for gradual and partial reviews to be\ndone by reviewers.","ref":"contributing.html#pull-requests-and-branching"},{"type":"extras","title":"Credits - Contributing","doc":"Euneus has been improved by\n[many contributors](https://github.com/williamthome/euneus/graphs/contributors)!","ref":"contributing.html#credits"},{"type":"extras","title":"Security","doc":"# Security policy\n\nThanks for helping make Euneus safer for everyone.\n\nFind below updated information on our security policy.","ref":"security.html"},{"type":"extras","title":"Security - Security","doc":"We take the security of this software seriously.\n\nWe don't implement a bug bounty program or bounty rewards, but will work with\nyou to ensure that your findings get the appropriate handling.","ref":"security.html#security"},{"type":"extras","title":"Reporting Security Issues - Security","doc":"If you believe you have found a security vulnerability in this repository,\nplease report it to  .\n\nPlease do not report security vulnerabilities through public channels, like\nGitHub issues, discussions, or pull requests.\n\nPlease include as much of the information listed below as you can to help us\nbetter understand and resolve the issue:\n\n- the type of issue (e.g., buffer overflow, SQL injection, or cross-site\n  scripting)\n- full paths of source file(s) related to the manifestation of the issue\n- the location of the affected source code (tag/branch/commit or direct URL)\n- any special configuration required to reproduce the issue\n- step-by-step instructions to reproduce the issue\n- proof-of-concept or exploit code (if possible)\n- impact of the issue, including how an attacker might exploit the issue\n\nThis information will help us triage your report more quickly.","ref":"security.html#reporting-security-issues"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}